export function sum(numbers: Iterable<number>) {
	let result = 0;
	for (const item of numbers) result += item;
	return result;
}
export async function parallel<I, O>(inputs: AsyncIterable<I>, operation: (item: I) => Promise<O>) {
	const promises = [] as Promise<O>[];
	for await (const input of inputs) promises.push(operation(input));
	return await Promise.all(promises);
}

export async function collect<T>(gen: AsyncIterable<T>) {
	const result = [] as T[];
	for await (const item of gen) result.push(item);
	return result;
}
